// Copyright 2010, Mark C. Chu-Carroll (markcc@gmail.com).
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
package com.pragprog.aebook.chat.client;

import java.util.List;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

//START: main
@RemoteServiceRelativePath("chat")
public interface ChatService extends RemoteService {

//START: Fetches
    void postMessage(ChatMessage messages);
    ChatMessageList getMessages(String room);
    ChatMessageList getMessagesSince(String chat, long timestamp);
//END: Fetches
  
//START: ChatMethods
    List<ChatRoom> getChats();
  
    void addChat(String chatname);
//END: ChatMethods
}
//END: main